<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '../common/meta';
import {
  NextStep as FeaturesCTA,
  SideNavigationVariant,
} from '../components/common/index';
import {
  SolutionsHero,
  SolutionsResourceCards,
} from '../components/solutions/index';
import {
  ByIndustryIntro,
  ByIndustryCaseStudies,
  ByIndustrySolutionsBlock,
} from '../components/solutions/by-industry/index';
import {
  BySolutionIntro,
  BySolutionBenefits,
  BySolutionValueProp,
} from '../components/solutions/by-solution/index';

export default Vue.extend({
  components: {
    SolutionsHero,
    ByIndustryIntro,
    SideNavigationVariant,
    BySolutionIntro,
    BySolutionBenefits,
    BySolutionValueProp,
    ByIndustryCaseStudies,
    ByIndustrySolutionsBlock,
    SolutionsResourceCards,
    FeaturesCTA,
  },
  async asyncData({ $content, error, i18n }: any) {
    try {
      const locale = i18n.locale === i18n.defaultLocale ? '' : i18n.locale;
      const enterprise = await $content(locale, 'enterprise').fetch();
      return { enterprise };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    const metaInfo = getPageMetadata(
      (this as any).enterprise,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
    const isInternationalization =
      this.$i18n.locale !== this.$i18n.defaultLocale;

    if (isInternationalization) {
      metaInfo.meta.push({
        hid: 'salesRobots',
        name: 'robots',
        content: 'noindex,nofollow',
      });
    }

    return metaInfo;
  },
});
</script>

<template>
  <div class="overflow-clip">
    <SolutionsHero :data="enterprise['solutions_hero']" />
    <ByIndustryIntro :data="enterprise['by_industry_intro']" />
    <SideNavigationVariant :links="enterprise['side_navigation_links']">
      <div id="overview" data-slippers-scroll="overview">
        <BySolutionIntro :data="enterprise['by_solution_intro']" :offset="2" />
        <BySolutionBenefits
          :data="enterprise['by_solution_benefits']"
          :offset="2"
        />
      </div>
      <BySolutionValueProp
        id="benefits"
        :data="enterprise['by_solution_value_prop']"
        :justify-content="true"
        data-slippers-scroll="benefits"
      />
      <div
        id="capabilities"
        class="slp-my-96"
        data-slippers-scroll="capabilities"
      >
        <ByIndustrySolutionsBlock
          :data="enterprise['by_industry_solutions_block']"
          :offset="2"
        />
      </div>
      <ByIndustryCaseStudies
        id="case-studies"
        :data="enterprise['by_industry_case_studies']"
        :offset="2"
        data-slippers-scroll="case-studies"
      />
    </SideNavigationVariant>
    <SolutionsResourceCards :data="enterprise['solutions_resource_cards']" />
    <FeaturesCTA />
  </div>
</template>
